/*
 * Copyright (C) 2017, hapjs.org. All rights reserved.
 */


const InjectPlugin = require('webpack-inject-plugin').default;

const entryKey = 'game'
const webpackConf = require('./webpack.config')
const subpackagesPath = []

// 将分包的入口转化成require的依赖项，从而打出兼容的整包
const entry = webpackConf.entry
for (const key in entry) {
  if (entry.hasOwnProperty(key)) {
     if(key !== entryKey){
        subpackagesPath.push(entry[key])
        delete entry[key]
     }    
  }
}

webpackConf.plugins.push(new InjectPlugin(function () {

  const str = subpackagesPath.reduce((acc, cur) => `require('${cur}');${acc}`, '')

  return `
      const loadSubpackage = function (params) {
        const success = params.success;
        const complete = params.complete;

        success();
        complete();
      };
      const sysInfo = qg.getSystemInfoSync();
      if(sysInfo.platformVersionCode >= 1051)
      {
        Object.defineProperty(qg, 'loadSubpackage', {
          value: loadSubpackage
        });
      }
      ${str}  
      `
}))

module.exports = webpackConf